HDU

来源:互联网 发布:兄弟连大数据 编辑:程序博客网 时间:2024/05/16 17:46

题目:
Jesus, what a great movie! Thousands of people are rushing to the cinema. However, this is really a tuff time for Joe who sells the film tickets. He is wandering when could he go back home as early as possible.
A good approach, reducing the total time of tickets selling, is let adjacent people buy tickets together. As the restriction of the Ticket Seller Machine, Joe can sell a single ticket or two adjacent tickets at a time.
Since you are the great JESUS, you know exactly how much time needed for every person to buy a single ticket or two tickets for him/her. Could you so kind to tell poor Joe at what time could he go back home as early as possible? If so, I guess Joe would full of appreciation for your help.
Input
There are N(1<=N<=10) different scenarios, each scenario consists of 3 lines:
1) An integer K(1<=K<=2000) representing the total number of people;
2) K integer numbers(0s<=Si<=25s) representing the time consumed to buy a ticket for each person;
3) (K-1) integer numbers(0s<=Di<=50s) representing the time needed for two adjacent people to buy two tickets together.
Output
For every scenario, please tell Joe at what time could he go back home as early as possible. Every day Joe started his work at 08:00:00 am. The format of time is HH:MM:SS am|pm.
Sample Input
2
2
20 25
40
1
8
Sample Output
08:00:40 am
08:00:08 am

思路:
题目大意就是说 每个人单独买票有个时间,与他左右相邻的人一起买票有另外一个时间,求这n个人买票的最短时间。 第i个人买票,他可以与第i-1个人一起,也可以自己单独买,所以有
dp[i] = min(dp[i-1] + one[i], dp[i-2] + two[i-1]);

代码:

#include <cstdio>#include <iostream>#include <algorithm>using namespace std;const int maxn = 2005;int one[maxn];int two[maxn];int dp[maxn];int main(){    int t;    scanf("%d",&t);    while(t--)    {        int n;        scanf("%d",&n);        for(int i = 0; i < n ; i++)            scanf("%d",&one[i]);        for(int i = 0; i < n-1; i++)            scanf("%d",&two[i]);        dp[0] = one[0];        dp[1] = min(one[0] + one[1], two[0]);        for(int i = 2; i < n ; i++)            dp[i] = min(dp[i-2] + two[i-1], dp[i-1] + one[i]);        int ans = dp[n-1];        int a = ans/3600,b = (ans - 3600*a) /60,c = (ans - 3600*a - 60 *b);        if(a+8 > 12) printf("%02d:%02d:%02d pm\n",a+8-12,b,c);        else if(a+8 == 12) printf("%02d:%02d:%02d pm\n",a+8,b,c);        else    printf("%02d:%02d:%02d am\n",a+8,b,c);    }    return 0;}
0 0